load:     call    sch
          jnc     l_fil
n_m:      lea     dx,no_mes
          call    mes
no_sym:   call    klv
          jz      no_sym
          ret

l_fil:    lea     di,l_mes+27
          call    psb
          lea     dx,l_mes
          call    mes
l_kl:     call    scan
          cmp     al,1Bh
          jz      rt
          cmp     ah,50h
          jne     l_ok
          mov     ah,4Fh
          int     21h
          jnc     l_fil
          jmp     n_m
l_ok:     cmp     al,13
          jnz     l_kl
          lea     dx,l_mes+27           ; 䠩
          mov     ax,3D02h
          mov     byte ptr r_w,3Fh
          call    rd_wr
          lea     dx,l_mes+27
rsav:     mov     bx,1135h
          call    mesk
          xor     ax,ax
rt:       ret



save:     call    sch                   ;  䠩 *.rom
          jnc     s_fil
n_ms:     mov     cx,8                  ;  䠩
          lea     di,in_mes+18
          push    di
          mov     al,32
rep       stosb
          xor     ax,ax
          stosw
          stosw
          pop     di
bg_st:    lea     dx,in_mes
          call    mes
          xor     ah,ah
          int     16h
          cmp     al,1Bh
          jz      jj
          cmp     al,0Dh
          jz      rt_st
          cmp     al,8
          jnz     no_del
          cmp     byte ptr [di-1],0     ;㤠 ᨬ
          jz      bg_st
          mov     al,32
          dec     di
          mov     byte ptr[di],al
          jmp     bg_st

no_del:   cmp     byte ptr [di],0       ; 饭 ᨬ
          jz      bg_st
          cmp     al,'_'
          jz      sts
          cmp     al,'@'
          jc      num
          and     al,0DFh
          cmp     al,5Bh
          jnc     bg_st
sts:      stosb
          jmp     bg_st
num:      cmp     al,3Ah
          jnc     bg_st
          cmp     al,30h
          jnc     sts
          jmp     bg_st

rt_st:    lea     si,fil+1
          mov     cx,5
rep       movsb
          lea     si,in_mes+18
          lea     di,s_mes+27
          call    psb2
          jmp     cr_f

s_fil:    lea     di,s_mes+27
          call    psb
          lea     dx,s_mes
          call    mes
s_kl:     call    scan
          cmp     al,1Bh
jj:       jz      rt2
          cmp     ah,50h
          jne     s_ok
          mov     ah,4Fh
          int     21h                   ;஢ઠ  稥
          jnc     s_fil                 ;䠩   
          jmp     n_ms
s_ok:
          cmp     al,13
          jnz     s_kl
cr_f:     lea     dx,s_mes+27           ;뢮 䠩
          mov     ah,3Ch                ;ᮧ/१ 䠩
          xor     cx,cx                 ;ਡ
          mov     byte ptr r_w,40h      ;write
          call    rd_wr

          lea     dx,s_mes+27
          jmp     rsav
rt2:      ret


psb:      mov     si,9Eh
psb2:     mov     cx,13
l_nam:
          movsb
          test    byte ptr ds:[si-1],0DFh
          jnz     len_ok
          dec     si
len_ok:   loop    l_nam
          ret

sch:      lea     dx,fil          ;  䠩  ७ *.rom
          xor     cx,cx
          mov     ah,4Eh
          int     21h
          ret

rd_wr:
          int     21h                   ;/ᮧ/१ 䠩
          jc      rt3
          mov     bx,ax                 ;᪮஢ ਯ
          push    ds
          mov     ax,b_seg
          mov     ds,ax
          xor     dx,dx
          mov     ax,cs:word ptr len
          mov     si,800h
          div     si
          and     ax,ax
          jnz     f_big
          inc     ax
          mov     si,cs:word ptr len
f_big:    mov     cx,ax                 ;- 横 ⥭/
cirs:     push    cx
          mov     cx,si
          and     cl,0F0h
          rol     cx,4
          xor     dx,dx
          db      0B4h                  ; mov ah,xx
r_w       db      0                     ;3F-read 40-write
          int     21h
          mov     cx,ds
          add     cx,si
          mov     ds,cx
          pop     cx
          loop    cirs
          pop     ds
          mov     ah,3Eh                ; 䠩
          int     21h
rt3:      ret

klv:      push    ds
          push    ax
          mov     ax,40h
          mov     ds,ax
          mov     ax,ds:[1Ch]
          cmp     ax,ds:[1Ah]
          pop     ax
          pop     ds
          ret
delay:
          push   ax               ;ନ஢ প 2 
          in     al,61h           ;ࠧ蠥 ࠡ 2- 
          and    al,0FCh
          inc    ax
          out    61h,al
          mov    al,0A6h
          cli
          out    43h,al           ;ணࠬ஢ ⮫쪮 襣 
          mov    al,20            ;T=(20-1)*107.264  = 2.038 
          out    42h,al
beg2:     mov    al,86h           ;饫
          out    43h,al
          in     al,42h           ;⥭ " "
          and    al,al
          jnz    beg2
          sti
          pop    ax
          ret

say_time: call  time
          push  ax
          mov   ah,2
          xor   bx,bx
          mov   dx,1035h
          int   10h               ;⠭   ६
          pop   ax
          mov   cl,5
          mov   bx,5493
          mul   bx
          mov   bx,10000          ;ॢ ⨪  ᥪ㭤
          div   bx
          mov   bx,1000
          push  ax
          mov   ax,dx
          xor   dx,dx
          div   bx
          mov   dx,ax
          pop   ax
          mov   bx,10
          jmp   pr
prt_num:  div   bx
pr:       or    cl,cl
          jz    to_out
          dec   cl
          push  dx
          xor   dx,dx
          call  prt_num
          pop   dx
to_out:   push  ax
          push  dx
          or    dl,'0'
pic:      mov   ah,2
          int   21h
          inc   cl
          mov   dl,2Eh
          cmp   cl,4
          jz    pic
          pop   dx
          pop   ax
          ret

tic:    ;  push   ax
         ; in     al,61h
         ; xor    al,2
         ; and    al,0FEh
         ; out    61h,al
         ; pop    ax
         ; ret



time:     push    bx
          push    es
          mov     ax,40h
          mov     es,ax
          mov     ax,word ptr es:[6Ch]
w_t:      cmp     ax,word ptr es:[6Ch]   ; 砫 ⨪ ⠩
          jz      w_t
          pop     es
          mov     bx,word ptr b_time
          mov     word ptr b_time,ax
          sub     ax,bx
          dec     ax                     ; প
          pop     bx
          ret

b_time: dd  1FFF00h
fil:    db  '*.ROM',0
no_mes: db  'Files *.rom not found !$'
l_mes:  db  'Load file ? (,Enter,Esc):              $'
s_mes:  db  'Save file ? (,Enter,Esc):              $'
in_mes: db  'Input file name :',0,'        ',0,'    $'
