lpt     equ     378h                ;  LPT

mes_wr:
        lea     dx,wr_mes
        call    mcan
        cmp     al,'Y'
        jnz     q_wr                ;⢥ত 
        call    time                ; 稪 ६ 믮
rom:    push    es
        mov     ax,780h
        call    port                ;2.55  뢮
        mov     ah,0Fh
        mov     al,byte ptr r_b2
        call    port
        mov     ah,3
        mov     al,byte ptr r_c2
        call    port
        xor     di,di               ;砫 
        mov     c_adr,di            ; 稪 訡
        mov     word ptr c_seg,2000h
        mov     cx,b_seg            ;砫 ᥣ
        mov     es,cx               ; 祩   es:di
        mov     ch,cs:byte ptr len+1
        rol     ch,4
        and     cx,0F00h            ; cl 訥 ,  ch  
        jnz     new_s
        inc     ch
new_s:  mov     bx,303h             ;砫쭠 ⠭ 横 
no_er:  call    read                ;⠭   al
        cmp     byte ptr k_key,'O'
        jnz     no_o
        and     al,byte ptr es:[di] ;Test Overwrite
        jmp     over
no_o:   cmp     byte ptr k_key,'F'
        jnz     no_f
        inc     di
        cmp     al,0FFh             ;Test FFh
        jz      no_w
        jmp     error
no_f:   cmp     byte ptr k_key,'R'
        jnz     no_r
        stosb                       ;Read
no_r:   cmp     byte ptr k_key,'V'
        jnz     no_c
over:   scasb                       ;Verify
        jz      no_w
error:  call    cal_er
no_c:   cmp     byte ptr k_key,'W'
        jnz     no_w
        call    write
no_w:   mov     ax,word ptr len
        and     ah,0Fh
        rol     ax,4
        cmp     ax,di
        jnz     new_s
        mov     ax,es
        add     ax,1000h
        mov     es,ax
        inc     cl
        cmp     cl,ch
        jnz      new_s
wr_qui: pop     es
;⨥ 殮  ᨣ  
        call    res                  ; 55   0  22
        ret


read:
        cmp     byte ptr k_key,'W'   ;஢ઠ ⥪饩 樨
        pushf                        ;࠭ 䫠
        jz      wr_on
        and     di,di
        jnz     ninit
wr_on:
        mov     ax,582h              ;ணࠬ஢ 55  ⥭
        call    port                 ; १  B
        mov     ah,0Bh
        mov     al,byte ptr r_a2     ;⠭  ⥭  22
        or      al,cl                ;⠭  A16,A17,A18
        call    port                 ;⠭   22
ninit:
        call    dcur                 ; ⥪騩 
        mov     ax,di
        mov     ah,9
        call    port                 ;訩  
        mov     ax,di
        popf                         ;⠭ 䫠 樨
        jz      wr_o
        and     al,al
        jnz     no_h
wr_o:   mov     al,ah                ;訩  
        mov     ah,1
        or      al,byte ptr r_c1     ;⠭    C
        call    port
no_h:   mov     ah,2Eh
        call    port                 ; 
        ret



write:
        cmp     al,byte ptr es:[di]
        jnz     smal
        cmp     bh,3
        jz      ok_wr
        mov     bl,bh
        mov     bh,2
        cmp     bl,10
        jnc     smal
        inc     bl
        inc     bl
smal:   call    wr_rom
        mov     bl,1
        inc     bh
        pop     ax
        lea     ax,no_er
        push    ax
        cmp     bh,64
        jc      no_ski
err_m:  lea     dx,er_mes  ;  㤠筮 ⪥ 
        call    mcan
        call    clear      ;㤠 ।饥 ᮮ饭
        cmp     al,1Bh
        jz      esc_q
        cmp     al,'R'
        jnz     no_ret
        pop     ax
        lea     ax,new_s
        jmp     n_skip
no_ret: cmp     al,'S'
        jnz     err_m
        call    cal_er
ok_wr:  inc     di
        in      al,60h
        and     al,7Eh
        jnz     no_ski     ;। ⨥ 'Esc'
        lea     dx,wr_ext
        call    mcan
        call    clear      ;㤠 ।饥 ᮮ饭
        cmp     al,'Y'
        jnz     no_ski
esc_q:  call    cal_er
        pop     ax         ;  'Esc'
        lea     ax,wr_qui
n_skip: push    ax         ;  ⥪   
no_ski: ret

wr_rom:
        mov     ah,0Bh
        mov     al,byte ptr w_a2     ;⠭   22
        or      al,cl                ;⠭  A16,A17,A18
        call    port
        mov     ax,580h              ;ணࠬ஢ 55  
        call    port                 ; १  B
        mov     ax,di
        mov     ah,9
        call    port                 ;訩  
        mov     ax,di
        mov     al,ah
        mov     ah,1
        or      al,byte ptr w_c1     ;⠭ 
        call    port
        mov     al,byte ptr es:[di]
        mov     ah,13                ;⠭   
        call    port
        mov     al,byte ptr w_a2     ;   ᪮ ணࠬ
        or      al,40h
        mov     ah,0Bh               ;প  ஫ ﭨ
        call    port                 ;ணࠬ  ah
wr_rep:
        call    delay
        dec     bl
        jnz     wr_rep
        and     al,0BFh
        call    port
        ret





res:    mov      ax,6F0h    ;'RESET' 55  ⨥ 殮  8
; ࠡ   ந ⮩ ணࠬ
port:   push     dx
        push     bx
        mov      bx,ax      ;࠭ ax  砩 ⢨ ⥭
        mov      dx,lpt     ;  LPT
        test     ah,20h
        jnz      n_dan
        out      dx,al      ; ⥭      設 
n_dan:  inc      dx
        inc      dx
        mov      al,ah
        out      dx,al
        test     ah,40h
        jz       n_reg
        dec      dx
        in       al,dx      ;379A -  ஫ ணࠬ
        mov      bh,al
        inc      dx
n_reg:  test     ah,20h
        jz       n_in
        dec      dx
        dec      dx
        in       al,dx
        mov      bl,al      ;378h - ⠭ 
        inc      dx
        inc      dx
n_in:   mov      al,0Ch
        and      al,ah      ;   ஬ 
        out      dx,al
        mov      ax,bx
        pop      bx
        pop      dx
        ret

cal_er: inc     word ptr c_adr
        jnz     no_seg
        add     word ptr c_seg,1000h
no_seg: ret




typ:    mov     dl,byte ptr c_rom    ;  ⥪饩 
        inc     dl                   ;㢥
typ0:   mov     byte ptr c_rom,dl
        mov     al,endrom-begrom     ;  
        mul     dl
        xor     dl,dl
        lea     si,begrom
        add     si,ax                ; 
        cmp     byte ptr [si],0      ;३  砫,
        jz      typ0                 ;᫨ ⠡ 稫
        mov     dx,si
        mov     bx,0935h
        call    mesk                 ;뢥 ⨯ 
        add     si,6                 ;砫  㤠
        lea     di,len               ;砫 ⠡ 㤠
        mov     cx,endrom-begrom-6   ;-   
rep     movsb                        ;᪮஢
        mov     ax,2000h
        mov     word ptr b_seg,ax    ;砫
        mov     word ptr c_seg,ax    ;⥪騩 ᥣ
        mov     word ptr c_adr,0     ;⥪騩 
        ret

uprg:   mov     al,byte ptr r_c2
        mov     ah,al
        dec     al
        and     al,0Fh
        and     ah,0F0h
        or      al,ah
        mov     byte ptr r_c2,al
        ret

next:
        mov     ax,word ptr b_seg
        add     ax,word ptr len
        cmp     ah,0A0h
        jnz     no_end
        mov     ah,20h
no_end: mov     word ptr b_seg,ax
        mov     word ptr c_seg,ax
        mov     word ptr c_adr,0
        ret

b_seg   dw  2000h                    ;砫 ᥣ
c_seg   dw  2000h                    ;⥪騩 ᥣ
c_adr   dw  0                        ;⥪騩  (c_seg*16+c_adr)
len     dw  0                        ;   ࠣ (len*16)
r_c1    db  0                        ; 1 55 ⥭
r_a2    db  0                        ; 2 55 ⥭
r_b2    db  0                        ;⨢ ⠪ 
r_c2    db  0                        ;.⠭, ணࠬ஢  ID
w_c1    db  0                        ; 1 55 
w_a2    db  0                        ; A2 55 
c_rom   db  0                        ;⥪饥 

;                    l_len_h r_c1 r_a2 r_b2 r_c2 w_c1 w_a2
begrom: db  '2716 $',80h,00h,008h,000h,028h,01Eh,008h,030h
endrom: db  '2732 $',00h,01h,000h,000h,024h,01Eh,000h,020h
        db  '2764 $',00h,02h,0C0h,000h,042h,01Eh,080h,020h
        db  '27128$',00h,04h,0C0h,000h,042h,01Eh,080h,020h
        db  '27256$',00h,08h,080h,000h,042h,01Eh,080h,020h
        db  '27512$',00h,10h,000h,000h,044h,01Eh,000h,020h
        db  '27010$',00h,20h,000h,000h,081h,01Eh,000h,020h
        db  '27020$',00h,40h,000h,000h,081h,01Eh,000h,020h
        db  '27040$',00h,80h,000h,000h,081h,01Eh,000h,020h
        db  0       ;end table

begup:  db  '26$'       ;0 - 祭
endup:  db  '25$'       ;1   .ணࠬ஢  w_lp
        db  '24$'       ;2
        db  '23$'       ;3
        db  '22$'
        db  '21$'
        db  '20$'
        db  '19$'
        db  '18$'
        db  '17$'
        db  '16$'
        db  '15$'
        db  '14$'
        db  '13$'
        db  '12$'
        db  '11$'
        db  0             ;end table

wr_mes: db  'Are you sure write ROM ? (Y,Any key)$'
wr_ext: db  'Are you sure exit ? (Y,Any key)$'
er_mes: db  'Write error (Retry, Skip, Esc)$'